VOYEUR: A Dump With a BASIC Difference
Version N2.0 for the NEC PC-8201A and 8300

by James Main Kenney


One of the principal features of the Kyocera notebooks, such as the Tandy Radio Shack TRS-80 Model 100 and the NEC PC-8201A, is their use of low-power (CMOS) static RAM which can store multiple files for long periods of time using only battery power.  This convenience tempts users to keep original programs and other valuable files in RAM without adequate back-up, with disasterous results should a "cold start" (system reinitialization) occur unexpectedly or be required by a locked-up program.  A cold start removes all user filenames from the menu and the system directory, but the "dead" files remain in RAM until overwritten.  Recovery procedures have long been used to salvage dead text (.DO) files, but dead tokenized BASIC (.BA) files have been considered unrecoverable.

VOYEUR is a general-purpose "dump" program which can be used to explore memory (and even alter it), and which has the (unique?) ability to translate the "tokens" in .BA files into the keywords they represent.  By itself, this is useful in revealing details of .BA file storage (such as the colon placed in front of every "ELSE" token) which may be of special interest to BASIC programmers.  VOYEUR also converts to decimal the line numbers, which are stored in 16-bit binary form.  By saving to text files these and other components of BASIC programs, dead .BA files can be translated into ASCII listings indentical to those obtained by normal .DO saves of live .BA files.

Instead of displaying an array of hex numbers, as "dump" programs commonly do, VOYEUR fills the screen, except for the bottom line, with characters representing the data bytes at 280 successive memory locations in the 8201A: far more than is possible for a hex dump, and text appears in an easily readable sequence.  Information about any byte, including data not directly available from a hex dump, can be read at the bottom of the screen by moving the cursor over the character representing it.  For data such as control code for which no characters have been defined, characters defined for other bytes are used and are distinguished by the use of reverse video.  (Since the 8201A does not provide characters for bytes 131-255, there are not enough characters to avoid ambiguity; as listed, VOYEUR N2.0 makes no provision for displaying or filing user-defined characters, but can be easily modified, in lines 1 and 22, to do so for specific byte ranges.)

Two improved versions of VOYEUR have been developed:  T2.0 for the Tandy M100, T200 and (untested) T102, and N2.0 for the NEC 8201A and (untested) 8300.  These are posted as VYRT20 and VYRN20, respectively.  Separate documentation is now available for these versions, although the articles published in Computer News 80 were for both.

Significant improvements have been made since version 1.0 was published in the March 1994 issue (Vol. 7. No. 3) of Computer News 80 (Casper, WY 82602-0680):

*  As a true "dump" should, VOYEUR can now file or print address/byte pairs in decimal, hex, or both, in place of, or in addition to, the characters (or BASIC keywords, etc.) associated with those bytes.
*  In BASIC mode, bytes higher than 127 within data strings are no longer incorrectly treated as tokens.
*  While re-scanning the screen, the cursor is now visible.
*  Jumping from one program line to another within a .BA file has been made easier.  (File selection in the directory is slightly different.)
*  When opening a file, the previously used filename (if one exists) is now the default, serving as a reminder of the last name used or facilitating reuse.
