Operating VOYEUR T2.0 (Part 1 of 3)


When VOYEUR is entered, its operating instructions are tersely outlined on two successive screens.  (The symbol ">" connects a key marking with its function, and may be read as either "to" or "for".)  At the first-screen prompt, enter an address for the scan to start at, or press only "ENTER" to select the file directory in system RAM, which can be recalled later with key "D".  (For all operations, upper or lower case letters may be used.)  The address prompt can also be recalled later, with key "A".

The second-screen prompt is for a search list, which may be useful at this point for quickly locating filenames in the directory:  Enter the names, or parts of names, using extensions only after becoming familiar with directory protocol.  The search prompt, which can be recalled later with key "S", will be discussed below in greater detail, and can be skipped at this point by pressing only "ENTER", after which scanning will start automatically.  Stop the scan at any point with (almost) any key, or it will stop after the screen is filled.  Restart scanning by pressing only "ENTER".

With the scan stopped, use the arrow (cursor) keys, the spacebar, or the backspace key to position the cursor.  For faster movement, note that the cursor will wrap around between opposite edges of the screen, including top and bottom and even between the display ends (bottom right and top left).  Holding down the shift key while pressing an arrow key causes the cursor to jump, the horizontal jump matching the filename spacing in the directory.  The cursor will seem less sluggish if hex numbers, toggled on or off by key "H", are not displayed.  The cursor is sufficiently visible when rescanning (reprinting the same characters) to enable it to be stopped at, or very close to, any screen position.

The address and byte (ASCII value) for any character displayed can be found by moving the cursor over that character and reading the separate decimal and (optional) hexadecimal values on the information line at the bottom of the screen.  Between the decimal and hex values is a copy of the character which, since it does not blink with the cursor, allows normal and reverse video to be distinguished.  Appearing at the left end, for bytes above 160, is the character for the byte reduced by 128.  A copy of any character already in the printable 7-bit ASCII range will also appear here.

To the right of the hex values or replacing them, also as an option, is the BASIC keyword, if there is one for that byte, or the BASIC line number, or any uncoded .BA file character.  Next, in decimal form, is the 16-bit binary value of the bytes represented by the two characters to the right of the cursor, i.e., at the next two higher addresses.  While copying to a file, the letter "F" appears at the right end.

Run (step forward automatically) with key "R", which is equivalent to repeated presses of the right arrow key or the spacebar.  Unlike scanning, running prints to the information line and permits copying to a file.  Running makes copying much easier than manual stepping and, unlike the latter, does not wrap around at the end of the last line: the screen will scroll and running will continue automatically with new addresses, allowing a large area of memory, such as a file, to be copied without intervention.  There are two running speeds: slow, without hex numbers, and even slower with them!

A file to copy to can be opened or closed by toggling key "F".  When opening, the "File" prompt is presented at which a filename can be entered or the default name accepted by pressing only "ENTER".  The default name is the last filename used since entering VOYEUR, if there is one, or "A" if not.  Special filenames or prefixes may be used for sending data to a printer, cassette, disk drive, or another computer, as shown in the manual (for the BASIC instruction "OPEN") and discussed briefly below in the section on data recovery (which also discusses sending data to a Booster Pak).  After entering a filename, a second prompt will appear, asking for a choice of: characters/BASIC only, addresses and bytes only, or both.  Press a number key ("0", "1", or "2", respectively) to make the selection; pressing any non-numeric key, such as "ENTER", will select the filing of characters (or BASIC keywords, etc.) only.  (The cursor rests on "0" as a default reminder.)  If key "1" or key "2" is pressed, a similar third prompt will appear asking for a choice of decimal, hex, or both, the non-numeric default being decimal only.
