Robert,

  LINE 9100 is changed in the version I sent you so as not to create as much overhead. Leave me a note if it isn't clear. Larry

---------------------------------------

       Documentation for LAP70.BA

  LAP70.BA is a RACE timing program 
originally written to time radio 
controlled race car events.  It can be 
used to time any event that is time 
oriented and has less than 10 entries 
and no more that a total of 450 laps.  
It is "Time" oriented and not "Lap" 
oriented, meaning you pick the length of
the race in minutes, not the number of 
laps.  The arrays can be changed for 
more or less laps, as expected, to 
conserve memory.
  As written it creates two output file,
HEATXX.DO which records the lap times of
each of the entries for future 
reference, and RRUNX.DO as input for the
program RACWY2.BA.  RACWY2.BA can rerun 
the original race in an amusing graphic 
form.

        ***Running LAP70.BA***

  The starting screen displays the 
current Files in RAM and asks you to 
"Enter the Heat Number"; any two 
characters are valid.  If you enter [1] 
it creates HEAT1.DO and RRUN1.DO upon 
completion of the race.  Next, it asks 
for the length of the race in minutes.  
Any time that doesn't exceed the array 
limits is valid.  If you entered [1] for
the heat # and [5] for the minutes the 
prerace screen would look as follows:

***************************************
*  5 Minute Race       Time           *
*  HIT ANY KEY TO START RACE!  HEAT1  *
*Car Laps  Time       Car Laps  Time  *
* 1                    6              *
* 2                    7              *
* 3                    8              *
* 4                    9              *
* 5                    0              *
***************************************

  When the cars/runners/etc. are ready 
to go Hit Any Key and wait for the 
beeper to signal the official start of 
the race.  As the cars cross the Start/
Finish line at the finish of their first
lap and subsequent laps hit the 
corresponding number 0-9 (the 0 is for 
car # 10).  Lap times are displayed next
to the car numbers for each lap along 
with the current lap number.  The 
fastest lap time is also displayed on 
the second line and the Elapsed time is 
counting up to the race limit in the 
upper righthand corner.  This is a 
typical screen after a minute and a 
half, with Fast Lap of 8.8 seconds going
to Car 7 on Lap 2.

***************************************
*  5 Minute Race       Time  1: 30: 0 *
* 7   2     8.8    Fast Lap    HEAT1  *
*Car Laps  Time       Car Laps  Time  *
* 1   5    16.0        6              *
* 2                    7   5    16.6  *
* 3   3    17.8        8              *
* 4   4    11.6        9              *
* 5   3    27.4        0              *
***************************************

  When the race time limit is reached 
the Beeper sounds and each car has 30 
seconds to finish their current lap.  
After 30 seconds the race is complete 
but there is some housekeeping that 
takes awhile to complete.

  DO NOT INTERUPT the program until it 
is done or the race records are not 
recorded.

The winner is indicated with an asterick
(*) by the car number.  The results of 
HEAT1 are recorded in HEAT1.DO by car 
number with the ending total screen at 
the end of the file.  Only the winner is
indicated and you'll have to figure out 
the rest of the order from the laps and 
finishing times.  That is, if Car 4 and 
Car 5 ran 20 laps and Car 4's time is 
less he would be the winner.  Cars that 
don't run are indicated with DNS, Did 
Not Start, and cars that started but 
didn't finish are flagged DNF, Did Not 
Finish.

The other file our example race creates 
is RRUN1.DO.  It can be used as input to
RACWY2.BA which gives a graphic rerun of
the race. You can optionally disable 
creating RRUNX.DO as noted below.

 ***LAP70.BA Limitations and OPTIONS***

  LAP70.BA is not a flawless program, as
you may find out.  Here are some of the 
limitations:
 -Due to M100/102 timing limitations (
ie. the Very Often routine) it is 
possible to get timing errors on 
occasion.
 -If a car has lapped the field and 
doesn't finish his last lap, ie. a DNF, 
he won't be shown as the winner.  You'll
get yelled at if you don't catch it.
 -Array A(450) in line 15 keeps track of
every lap for every car and if RRUNX.DO 
isn't needed that array can be 
eliminated.
 -If you want to change the 30 second 
last lap limit modify line 185 from VAL(
S$)>29 to whatever time is appropriate.
 -If you don't want/need the detail by 
each car add line 9050 GOTO 9300.
 -To disable RRUNX.DO eliminate the 
remark apostrophe, ['], in line 9346 so 
it branches to the end without creating 
RRUNX.DO.

  Any questions or suggestions, feel 
free to contact me on this BBS. Best of 
luck and enjoy your racing.
     Larry Fletcher

