        DOCUMENTATION OF K - by Ron Wiesen
 
What K Does for You
 
K kills files that are in memory.  At the main menu of the laptop, you place the wide cursor bar on the name of the file you want to kill and then you invoke K.  K kills the file and the file name is removed from the main menu.
 
Unlike the BASIC command KILL which is finicky and insists on meticulous file names, K kills a file regardless of the file name.  With BASIC for example, KILL"0MYIQ.DO" gives 'NM Error' because it can't accept names that begin with a non-letter, but K kills the file without complaint.  So when things go amuck as they sometimes do and you're left with a file name from hell, K lets you get rid of it.
 
How You Invoke K
 
K can only be invoked at the main laptop menu.  You type a warm-key sequence and subsequently you press the enter [ENTER] key.  As you type a warm-key sequence, the characters of the sequence show on the Select line.  Note that K is invoked when you press the [ENTER] key only if you typed the warm-key sequence beforehand.
 
Three Step Operation
 
The three steps to kill a file are: select the file name with the cursor; type the warm-key sequence; press the [ENTER] key.  It does not matter whether you type the warm-key sequence before or after you move the cursor to select the file name.  Either way, you press the [ENTER] key as the last step.
 
Default Warm-key Sequence
 
The default warm-key sequence for K is just the minus [-] key.  The default has several advantages.  The [-] key is proximate to the arrow keys and the enter [ENTER] key so with one hand it's easy to move the wide cursor bar (arrow keys) and then invoke K.  It's a 1-character 1-stroke sequence where the character is the minus sign and you type it with one stroke of the [-] key.  When you stroke the [-] key, the same character is produced regardless of the [NUM] key setting.
 
Other Warm-key Sequences
 
You may define a warm-key sequence of your own liking when you install K.  Note that the state of the [NUM] key setting matters where the letter keys [I], [J], [K], [L], [M], [O], or [U] part of a warm-key sequence.
 
If you define a 1-character 1-stroke sequence such as the letter K (reminds you of Kill), then compared to invoking BASIC and using the command KILL"GOAWAY.BA" which involves many strokes on the keyboard while you remember the file name, K takes less effort and time.  It makes life simple.  Even with the [NUM] key acting as a kill-protect switch, perhaps it's too simple and prone to accidental operation; oops!
 
If you define a 1-character 2-stroke sequence such as the left-arrow, then you must depress and hold the [GRPH] key while you press the [K] key to type the warm-key sequence.  Because the [GRPH] and [K] keys are not proximate to each other, this warm-key sequence is not prone to accidental operation.  Note that the setting of the [NUM] key does not matter for characters produced in conjunction with the [GRPH] or [CODE] keys.
 
Here are the rules to follow to define a warm-key sequence.
 
1.  The sequence may have from 1 to 9 characters.  You define from 1 to 8 characters.  Where you define more than 6 characters, the period [.] is not defined by you but it becomes the 7th character of the sequence.  For example, you define 7 characters as [1][2][3][4][5][6][7] and the warm-key sequence [1][2][3][4][5][6][.][7] results.
 
2.  The control characters CTRL A to CTRL Z and BKSP can't be defined.
 
3.  The lower case letters a to z should not be defined because letter keystrokes produce only uppercase letters in a warm-key sequence.
 
4.  Space should not be defined for the first character because the space bar key advances the wide cursor bar at the main menu.  Space may be defined for characters that follow the lead character.
 
5.  Where less than 8 characters are defined, all remaining trail-characters must be defined as spaces.  Note that where trail-spaces must be defined, they are not part of the warm-key sequence.
 
6.  One or more space characters may be defined where non-space characters precede and follow.  For example, dash space dash [-][ ][-] may be defined.
 
7.  Any character with an extended code from 129 to 255, such as the left-arrow character which is code 155, may be defined.  Note that these are not ASCII characters, so if any are defined within the BASIC installation file K.BA, then you can not transport it in ASCII form.  RUN"COM:98N1E for example won't work properly.
 
Here a few warm-key sequences you may like.
 
[GRPH]+['] 1-char/2-stroke nearly equal
[GRPH]+[E] 1-char/2-stroke left-triangle
[GRPH]+[-] 1-char/2-stroke \ back-slash
[GRPH]+[SHIFT]+[-] 1-char/3-stroke | pipe
[GRPH]+[SHIFT]+[Z] 1-char/3-stroke blank graphic block (looks like a space)
[-][.][-] 3 1-stroke chars -.- (looks like an unused file name slot on menu)
[K][.][C][O] 4 1-stroke chars K.CO (K really is a .COmmand file)
 
Installation
 
File K.BA is a BASIC program for installation of K.  A warm-key sequence is defined within line 0 of the K.BA file.  The portion of line 0 that contains the default warm-key sequence is shown below.
 
D$="-       ":FORI=0TO7
 
The 8 character positions between the quotation marks define the warm-key sequence.  So if you want to change the warm-key sequence, then edit these positions, according to the rules under 'Other Warm-key Sequences', but be sure that you maintain 8 character positions.
 
Run K.BA to install K.  It takes a few seconds and then ends with the 'Ok' message.  If you run it again, another instance of K is installed.  Each instance occupies one file name slot on the main menu.
 
So if you want to experiment with different warm-key sequences, then run K.BA (e.g., with default) to get one instance, edit line 0, and run it again to get the next instance with a different warm-key sequence.
 
Removal of K
 
To remove any instance of K, place the wide cursor bar on it and then press the enter [ENTER] key.  Every instance of K is self-killing in this fashion.
 
Requirements of K
 
After installation, K has few requirements:
 
1.  Occupies 59 bytes of free memory (6-byte command file header plus 53 bytes of code).
 
2.  Occupies one file name slot on main menu.
 
Note that K occupies no hooks (warm-key, not hot-key invocation), has no HIMEM requirement for invocation (operates above MAXRAM), and consumes no free memory when invoked.
 
Miscellaneous
 
When K kills a file that is not a BASIC file type, the screen goes blank for a second before the main menu reappears.  For BASIC file types, 'Ok' and 'MENU' flash on the screen just before the main menu reappears - this is normal.
 
K purposely ignores the first 5 file name slots.  This means that if you place the wide bar cursor on one of the built-in applications (BASIC, TEXT, TELCOM, ADDRSS, or SCHEDL) and invoke K, nothing happens.  But if you have rearranged the internal order of the directory (tricky techno stuff), then be careful with K or you'll cause a cold-start if you try to kill a built-in application.
 
Unless you define a warm-key sequence that is a legitimate .COmmand file name (like K.CO) as far as file transfer utilities (TS-DOS, FLOPPY, RAM100.CO, etc.) are concerned, don't save the command file form of K to an external media.  Instead, save the K.BA file which such utilities correctly recognize as a BASIC file based on the .BA extension.
 
Because K operates (its origin is) in the keyboard typeahead buffer, no image of it remains there long enough for you to disassemble its code.  You can disassemble its image within its command file, but why bother - if you're that interested contact me for its source assembly file:
 
    Ron Wiesen Technical Products
    111 Gary Lane
    Cocoa, Fla. 32922
    Tel: (407) 632-6864
